"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Default = void 0;
var _react = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("react"));
var _styledComponents = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("styled-components"));
var _Image = /*#__PURE__*/require("../Image");
var _Typography = /*#__PURE__*/require("../Typography");
var _ = /*#__PURE__*/require(".");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
// TODO: https://github.com/salute-developers/plasma/issues/507

var items = /*#__PURE__*/Array(25).fill({
  title: 'Заголовок',
  subtitle: 'Описание уравнение времени, сублимиpуя с повеpхности ядpа кометы, вращает реликтовый ледник',
  imageSrc: 'images/320_320_n.jpg'
}).map(function (_ref, i) {
  var title = _ref.title,
    subtitle = _ref.subtitle,
    imageSrc = _ref.imageSrc;
  return {
    id: i,
    title: "".concat(title, " ").concat(i),
    subtitle: "".concat(subtitle, " ").concat(i),
    imageSrc: imageSrc.replace('n', i % 12)
  };
});
var StyledCard = /*#__PURE__*/_styledComponents["default"].div.withConfig({
  componentId: "plasma-b2c__sc-1nukb5m-0"
})(["position:relative;border-radius:1rem;"]);
var StyledCardContent = /*#__PURE__*/_styledComponents["default"].div.withConfig({
  componentId: "plasma-b2c__sc-1nukb5m-1"
})(["position:absolute;left:0;right:0;bottom:0;padding:1.72rem;color:#fff;"]);
var defaultCarouselStyle = {
  margin: '0 -0.5rem'
};
var defaultCarouselItemStyle = {
  width: 550,
  padding: '0 0.5rem'
};
var onIndexChange = function onIndexChange() {};
var defaultProps = {
  align: 'center'
};
var Default = exports.Default = function Default() {
  var align = defaultProps.align;
  return /*#__PURE__*/_react["default"].createElement(_.Carousel, {
    style: defaultCarouselStyle,
    index: 0,
    detectActive: true,
    onIndexChange: onIndexChange,
    scrollAlign: align
  }, items.map(function (item) {
    return /*#__PURE__*/_react["default"].createElement(_.CarouselItem, {
      key: item.id,
      style: defaultCarouselItemStyle,
      scrollSnapAlign: align
    }, /*#__PURE__*/_react["default"].createElement(StyledCard, null, /*#__PURE__*/_react["default"].createElement(_Image.Image, {
      src: item.imageSrc,
      ratio: "16 / 9",
      base: "div"
    }), /*#__PURE__*/_react["default"].createElement(StyledCardContent, null, /*#__PURE__*/_react["default"].createElement(_Typography.Headline4, null, item.title), /*#__PURE__*/_react["default"].createElement(_Typography.Footnote1, null, item.subtitle))));
  }));
};