'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('../../../_virtual/_rollupPluginBabelHelpers.js');
var React = require('react');
var plasmaNewHope = require('@salutejs/plasma-new-hope');
var styled = require('styled-components');
var plasmaIcons = require('@salutejs/plasma-icons');
var Dropdown_config = require('../Dropdown.config.js');

var _excluded = ["children", "isOpen", "trigger", "placement", "disabled", "closeOnSelect", "onToggle", "onItemClick", "onItemSelect", "listOverflow", "listHeight", "items", "itemRole", "onHover", "handleClick", "onGlobalClose"];
var mergedConfig = /*#__PURE__*/plasmaNewHope.mergeConfig(plasmaNewHope.dropdownConfig, Dropdown_config.config);
var DropdownNewHope = /*#__PURE__*/plasmaNewHope.component(mergedConfig);
var mergedItemConfig = /*#__PURE__*/plasmaNewHope.mergeConfig(plasmaNewHope.dropdownItemConfig);
var DropdownNewHopeItem = /*#__PURE__*/plasmaNewHope.component(mergedItemConfig);
var DropdownWrapper = /*#__PURE__*/styled.div.withConfig({
  componentId: "plasma-b2c__sc-1gptfah-0"
})(["& .popover-wrapper,& .popover-target{display:block;}& .popover-root{height:", ";overflow:", ";}"], function (_ref) {
  var listHeight = _ref.listHeight;
  return !Number.isNaN(Number(listHeight)) ? "".concat(listHeight, "rem") : listHeight;
}, function (_ref2) {
  var listOverflow = _ref2.listOverflow;
  return listOverflow;
});
var StyledContent = /*#__PURE__*/styled.div.withConfig({
  componentId: "plasma-b2c__sc-1gptfah-1"
})(["display:inline-flex;margin-right:0.375rem;"]);
var DropdownItem = function DropdownItem(_ref3) {
  var item = _ref3.item,
    index = _ref3.index,
    itemRole = _ref3.itemRole,
    handleClick = _ref3.handleClick,
    handleOnHover = _ref3.handleOnHover,
    contentRight = _ref3.contentRight;
  return (
    /*#__PURE__*/
    // eslint-disable-next-line jsx-a11y/mouse-events-have-key-events
    React.createElement(DropdownNewHopeItem, {
      key: item.value,
      value: item.value,
      onClick: function onClick(e) {
        if (handleClick) {
          handleClick(item, e);
        }
      },
      onMouseOver: function onMouseOver() {
        return handleOnHover(index);
      },
      role: itemRole,
      disabled: item.isDisabled,
      contentLeft: /*#__PURE__*/React.createElement(StyledContent, null, item.contentLeft),
      contentRight: contentRight,
      text: item.label,
      style: {
        color: item.color
      }
    })
  );
};
var DropdownInner = function DropdownInner(_ref4) {
  var children = _ref4.children,
    _ref4$closeOnSelect = _ref4.closeOnSelect,
    closeOnSelect = _ref4$closeOnSelect === void 0 ? true : _ref4$closeOnSelect,
    onItemClick = _ref4.onItemClick,
    onItemSelect = _ref4.onItemSelect,
    items = _ref4.items,
    itemRole = _ref4.itemRole,
    onHover = _ref4.onHover,
    onGlobalClose = _ref4.onGlobalClose;
  var _useState = React.useState(false),
    _useState2 = _rollupPluginBabelHelpers.slicedToArray(_useState, 2),
    isOpen = _useState2[0],
    setIsOpen = _useState2[1];
  var handleToggle = function handleToggle(currentState, _) {
    setIsOpen(currentState);
  };
  var handleOnHover = function handleOnHover(index) {
    if (onHover) {
      onHover(index);
    }
  };
  var handleClick = function handleClick(item, event) {
    if (onItemClick) {
      onItemClick(item, event);
    }
    if (onItemSelect) {
      onItemSelect(item, event);
    }
    if (closeOnSelect && onGlobalClose) {
      onGlobalClose();
    }
  };
  return /*#__PURE__*/React.createElement(DropdownNewHope, {
    target: children,
    isOpen: isOpen,
    onToggle: handleToggle,
    trigger: "hover",
    placement: "right",
    offset: [0, 0]
  }, items.map(function (item, index) {
    return item.items ? /*#__PURE__*/React.createElement(DropdownInner, {
      key: index,
      items: item.items,
      role: itemRole,
      closeOnSelect: closeOnSelect,
      onItemClick: onItemClick,
      onItemSelect: onItemSelect,
      onHover: onHover,
      onGlobalClose: onGlobalClose
    }, /*#__PURE__*/React.createElement(DropdownItem, {
      item: item,
      index: index,
      itemRole: itemRole,
      handleOnHover: handleOnHover,
      handleClick: handleClick,
      contentRight: plasmaIcons.IconDisclosureRight
    })) : /*#__PURE__*/React.createElement(DropdownItem, {
      key: index,
      item: item,
      index: index,
      itemRole: itemRole,
      handleOnHover: handleOnHover,
      handleClick: handleClick
    });
  }));
};
var DropdownUncontrolled = /*#__PURE__*/React.forwardRef(function (_ref5, ref) {
  var children = _ref5.children,
    isOpen = _ref5.isOpen,
    trigger = _ref5.trigger,
    _ref5$placement = _ref5.placement,
    placement = _ref5$placement === void 0 ? 'bottom' : _ref5$placement,
    disabled = _ref5.disabled,
    _ref5$closeOnSelect = _ref5.closeOnSelect,
    closeOnSelect = _ref5$closeOnSelect === void 0 ? true : _ref5$closeOnSelect,
    onToggle = _ref5.onToggle,
    onItemClick = _ref5.onItemClick,
    onItemSelect = _ref5.onItemSelect,
    listOverflow = _ref5.listOverflow,
    listHeight = _ref5.listHeight,
    items = _ref5.items,
    itemRole = _ref5.itemRole,
    onHover = _ref5.onHover,
    handleClick = _ref5.handleClick,
    onGlobalClose = _ref5.onGlobalClose,
    rest = _rollupPluginBabelHelpers.objectWithoutProperties(_ref5, _excluded);
  var handleOnHover = function handleOnHover(index) {
    if (onHover) {
      onHover(index);
    }
  };
  return /*#__PURE__*/React.createElement(DropdownWrapper, {
    listHeight: listHeight,
    listOverflow: listOverflow
  }, /*#__PURE__*/React.createElement(DropdownNewHope, _rollupPluginBabelHelpers.extends({}, rest, {
    ref: ref,
    target: children,
    isOpen: isOpen,
    onToggle: onToggle,
    trigger: trigger,
    placement: placement,
    offset: [0, 0],
    closeOnOverlayClick: true
  }), !disabled && items.map(function (item, index) {
    return item.items ? /*#__PURE__*/React.createElement(DropdownInner, {
      key: index,
      items: item.items,
      itemRole: itemRole,
      closeOnSelect: closeOnSelect,
      onItemClick: onItemClick,
      onItemSelect: onItemSelect,
      onHover: onHover,
      onGlobalClose: onGlobalClose
    }, /*#__PURE__*/React.createElement(DropdownItem, {
      item: item,
      index: index,
      itemRole: itemRole,
      handleOnHover: handleOnHover,
      handleClick: handleClick,
      contentRight: plasmaIcons.IconDisclosureRight
    })) : /*#__PURE__*/React.createElement(DropdownItem, {
      key: index,
      item: item,
      index: index,
      itemRole: itemRole,
      handleOnHover: handleOnHover,
      handleClick: handleClick
    });
  })));
});

exports.DropdownNewHopeItem = DropdownNewHopeItem;
exports.DropdownUncontrolled = DropdownUncontrolled;
//# sourceMappingURL=DropdownUncontrolled.js.map
